Index: EcnlProtoTool/trunk/asp3_dcre/tecsgen/tecslib/core/componentobj.rb
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tecsgen/tecslib/core/componentobj.rb	(revision 299)
+++ EcnlProtoTool/trunk/asp3_dcre/tecsgen/tecslib/core/componentobj.rb	(revision 321)
@@ -5670,8 +5382,8 @@
       @@region_count      = through[ 6 ]
     else
-      # å¼ã³å£ã® through ã®å ´å
-      @@start_region      = @owner.get_region    # å¼ã³å£å´ã»ã«ã® region
-      @@end_region        = next_cell.get_region # æ¬¡ã®ã»ã«ã® region
-      @@through_type      = :THROUGH             # å¼ã³å£ã® through æå®
+      # 呼び口の through の場合
+      @@start_region      = @owner.get_region    # 呼び口側セルの region
+      @@end_region        = next_cell.get_region # 次のセルの region
+      @@through_type      = :THROUGH             # 呼び口の through 指定
       @@region_count      = 0
     end
@@ -5687,5 +5399,5 @@
 
     begin
-      eval( eval_str )     # plugin ãçæ
+      eval( eval_str )     # plugin を生成
       plugin_object.set_locale @locale
     rescue Exception => evar
@@ -5702,7 +5414,6 @@
     @through_generated_list[ i ] = plugin_object
 
-    # Region ã«é¢ããæ
-å ±ãè¨­å®
-    # å¾ããè¿½å ããã®ã§ãnew ã®å¼æ°å¤ã§è¨­å®
+    # Region に関する情報を設定
+    # 後から追加したので、new の引数外で設定
     # plugin_object.set_through_info( start_region, end_region, through_type )
 
@@ -5710,6 +5421,6 @@
   end
 
-  #ãã©ã°ã¤ã³ã¸ã®å¼æ°ã§æ¸¡ããªããã®ããä¸æçã«è¨æ¶ãã¦ãã
-  # ãã©ã°ã¤ã³ã® initialize ã®ä¸­ã§ã³ã¼ã«ããã¯ãã¦è¨­å®ãã
+  #プラグインへの引数で渡さないものを、一時的に記憶しておく
+  # プラグインの initialize の中でコールバックして設定する
   @@plugin_creating_join = nil
   @@start_region = nil
@@ -5718,9 +5429,7 @@
   @@region_count = nil
 
-  #=== Join# ThroughPlugin ã®è¿½å æ
-å ±ãè¨­å®ãã
-  # ãã®ã¡ã½ããã¯ ThroughPlugin#initialize ããå¼ã³åºããã
-  # plugin_object ãçæããéã®å¼æ°ã§ã¯ä¸è¶³ããæ
-å ±ãè¿½å ãã
+  #=== Join# ThroughPlugin の追加情報を設定する
+  # このメソッドは ThroughPlugin#initialize から呼び出される
+  # plugin_object を生成する際の引数では不足する情報を追加する
   def self.set_through_info plugin_object
     plugin_object.set_through_info( @@start_region, @@end_region, @@through_type,
@@ -5734,13 +5443,11 @@
   end
 
-  #=== Join#é
-åæ·»æ°ãå¾ã
-  # @subscript ã®èª¬æãåç
-§ã®ãã¨
+  #=== Join#配列添数を得る
+  # @subscript の説明を参照のこと
   def get_subscript
     @subscript
   end
 
-  def get_cell_name         # åãå£ã»ã«å
+  def get_cell_name         # 受け口セル名
     @cell_name
   end
@@ -5754,42 +5461,39 @@
   end
 
-  #=== Join# å³è¾ºã®å®ã»ã«ãå¾ã
-  #    å®ã»ã«ã¨ã¯ through ã§æ¿å
-¥ããããã®ãcomposite ã®å
-é¨ãªã©å®éã«çµåãããå
-
-  #    ãã®ã¡ã½ããã¯ãget_rhs_port ã¨å¯¾ã«ãªã£ã¦ãã
-  #    ãã®ã¡ã½ããã¯ãæå³è§£ææ®µéã§ã¯å¼ã³åºãã¦ã¯ãªããªã (å¯¾è±¡ã»ã«ã®æå³è§£æãæ¸ãåã«ã¯æ­£ããçµæãè¿ããªã)
+  #=== Join# 右辺の実セルを得る
+  #    実セルとは through で挿入されたもの、composite の内部など実際に結合される先
+  #    このメソッドは　get_rhs_port と対になっている
+  #    このメソッドは、意味解析段階では呼び出してはならない (対象セルの意味解析が済む前には正しい結果を返さない)
   def get_rhs_cell
-    # through æå®ããï¼
+    # through 指定あり？
     if @through_list[0] then
-      # mikan through ã§çæãããã®ã root namespace éå®
+      # mikan through で生成したものが root namespace 限定
       if @through_generated_list[0] then
         # cell = Namespace.find( [ "::", @through_generated_list[0].get_cell_name.to_sym ] )    #1
         cell = Namespace.find( @through_generated_list[0].get_cell_namespace_path )    #1
-        # cell ã nil ã«ãªãã®ã¯ãã©ã°ã¤ã³ã® get_cell_namespace_path ãæ­£ãããªããã
-        # ãã©ã°ã¤ã³çæã³ã¼ããã¨ã©ã¼ã«ãªã£ã¦ããã
-        # ã§ãã®æªããã©ã°ã¤ã³ãå¤ããã°ãcell == nil ãã¯ãããæ¹ãããã
+        # cell が nil になるのはプラグインの get_cell_namespace_path が正しくないか、
+        # プラグイン生成コードがエラーになっている。
+        # できの悪いプラグインが多ければ、cell == nil をはじいた方がよい。
         return cell.get_real_cell( @through_generated_list[0].get_through_entry_port_name )
       else
-        return nil            # generate ã«å¤±æãã¦ãã
+        return nil            # generate に失敗している
       end
     elsif @cell then
       return @cell.get_real_cell( @port_name )
     else
-      # å³è¾ºãæªå®ç¾©ã®å ´å @cell ã¯ nil (æ¢ã«ã¨ã©ã¼)
+      # 右辺が未定義の場合 @cell は nil (既にエラー)
       return nil
     end
   end
 
-  #=== Join# å³è¾ºã®ã»ã«ãå¾ã
-  # å³è¾ºã®ã»ã«ãå¾ãããã ããcomposite å±éããã¦ããªã
-  # composite å±éããããã®ãå¾ãã«ã¯ get_rhs_cell ãä½¿ã
-  # ãã­ãã¿ã¤ãå®£è¨ããããã¦ããªãå ´åã«ã¯ããã¡ãããä½¿ããªã
-  # ãã®ã¡ã½ããã¯ get_rhs_port2 ã¨å¯¾ã«ãªã£ã¦ãã
+  #=== Join# 右辺のセルを得る
+  # 右辺のセルを得る。ただし、composite 展開されていない
+  # composite 展開されたものを得るには get_rhs_cell を使う
+  # プロトタイプ宣言しかされていない場合には、こちらしか使えない
+  # このメソッドは get_rhs_port2 と対になっている
   def get_rhs_cell2
-    # through æå®ããï¼
+    # through 指定あり？
     if @through_list[0] then
-      # mikan through ã§çæãããã®ã root namespace éå®
+      # mikan through で生成したものが root namespace 限定
       # cell = Namespace.find( [ "::", @through_generated_list[0].get_cell_name ] )
       if @through_generated_list[0] then
@@ -5797,5 +5501,5 @@
         cell = Namespace.find( @through_generated_list[0].get_cell_namespace_path )    #1
       else
-        cell = @cell            # generate ã«å¤±æãã¦ãã
+        cell = @cell            # generate に失敗している
       end
     else
@@ -5806,8 +5510,8 @@
   end
 
-  #=== Join# å³è¾ºã®ã»ã«ãå¾ã
-  # through ã¯é©ç¨ããªãããcomposite ã¯å±éããå¾ã®ã»ã«
-  # (æå³è§£æãçµãã£ã¦ããªãã¨ãcomposite å±éãçµãã£ã¦ããªã)
-  # ãã®ã¡ã½ããã¯ get_rhs_port3 ã¨å¯¾ã«ãªã£ã¦ãã
+  #=== Join# 右辺のセルを得る
+  # through は適用しないが、composite は展開した後のセル
+  # (意味解析が終わっていないと、composite 展開が終わっていない)
+  # このメソッドは get_rhs_port3 と対になっている
   def get_rhs_cell3
     if @cell then
@@ -5816,13 +5520,13 @@
   end
 
-  #=== Join# å³è¾ºã®ã»ã«ã®ãªã¼ã¸ã§ã³ãå¾ã
-  # å³è¾ºãæªå®ç¾©ã®å ´åãnil ãè¿ã
-  # composite ã®å ´åãå®ã»ã«ã§ã¯ãªã composite cell ã® region ãè¿ã(composite ã¯ãã¹ã¦åã region ã«å±ãã)
-  # composite ã® cell ããã­ãã¿ã¤ãå®£è¨ããã¦ããã¨ã get_rhs_cell/get_real_cell ã¯ ruby ã®ä¾å¤ã¨ãªã
+  #=== Join# 右辺のセルのリージョンを得る
+  # 右辺が未定義の場合、nil を返す
+  # composite の場合、実セルではなく composite cell の region を返す(composite はすべて同じ region に属する)
+  # composite の cell がプロトタイプ宣言されているとき get_rhs_cell/get_real_cell は ruby の例外となる
   def get_rhs_region
-    # through æå®ããï¼
+    # through 指定あり？
     if @through_list[0] then
       if @through_generated_list[0] then
-        # mikan through ã§çæãããã®ã root namespace éå®
+        # mikan through で生成したものが root namespace 限定
         # cell = Namespace.find( [ "::", @through_generated_list[0].get_cell_name.to_sym ] )    #1
         cell = Namespace.find( @through_generated_list[0].get_cell_namespace_path )    #1
@@ -5831,15 +5535,14 @@
         end
       else
-        return nil       # generate ã«å¤±æãã¦ãã
+        return nil       # generate に失敗している
       end
     elsif @cell then
       return @cell.get_region
     end
-    # å³è¾ºãæªå®ç¾©ã®å ´å @cell ã¯ nil (æ¢ã«ã¨ã©ã¼)
+    # 右辺が未定義の場合 @cell は nil (既にエラー)
     return nil
   end
 
-  def get_cell_global_name  # åãå£ã»ã«åï¼ã³ã³ãã¸ãããªãå±éããå
-å´ã®ã»ã«ï¼
+  def get_cell_global_name  # 受け口セル名（コンポジットなら展開した内側のセル）
 
     # debug
@@ -5855,29 +5558,24 @@
   end
 
-  #===  Join# çµåã®å³è¾ºã®åãå£ã®åå
-  #     namespace å + '_' + ã»ã«å + '_' + åãå£å   ï¼ãã®ã»ã«ã composite ãªãã°å±éå¾ã®ã»ã«åãåãå£åï¼
-  #subscript:: Integer  å¼ã³å£é
-åã®ææ·»æ° ã¾ãã¯ nil å¼ã³å£é
-åã§ãªãæ
-  def get_port_global_name( subscript = nil )  # åãå£åï¼ã³ã³ãã¸ãããªãå±éããå
-å´ã®ã»ã«ï¼
+  #===  Join# 結合の右辺の受け口の名前
+  #     namespace 名 + '_' + セル名 + '_' + 受け口名   （このセルが composite ならば展開後のセル名、受け口名）
+  #subscript:: Integer  呼び口配列の時添数 または nil 呼び口配列でない時
+  def get_port_global_name( subscript = nil )  # 受け口名（コンポジットなら展開した内側のセル）
 
     # debug
     dbgPrint "Cell get_port_global_name:  #{@cell_name}\n"
 
-    # through æå®ããï¼
+    # through 指定あり？
     if @through_list[0] then
 
-      # mikan through ã§çæãããã®ã root namespace éå®
+      # mikan through で生成したものが root namespace 限定
       # cell = Namespace.find( [ "::", @through_generated_list[0].get_cell_name.to_sym ] )    #1
       cell = Namespace.find( @through_generated_list[0].get_cell_namespace_path )    #1
 
-      # through ã§æ¿å
-¥ãããã»ã«ã§ãå®éã«æ¥ç¶ãããã»ã«ï¼compositeã®å ´åå
-é¨ã®)ã®åãå£ã® C è¨èªåå
+      # through で挿入されたセルで、実際に接続されるセル（compositeの場合内部の)の受け口の C 言語名前
       return cell.get_real_global_port_name( @through_generated_list[0].get_through_entry_port_name )
     else
 
-      # å®éã«æ¥ç¶ãããã»ã«ã®åãå£ã® C è¨èªåå
+      # 実際に接続されるセルの受け口の C 言語名前
       if @cell then
         return @cell.get_real_global_port_name( @port_name )
@@ -5902,36 +5600,32 @@
   end
 
-  #=== Join# å³è¾ºã®ãã¼ããå¾ã
-  #    å³è¾ºã composite ã®å ´åã¯ãå
-é¨ã®ç¹ããã»ã«ã®ãã¼ã, through ã®å ´åã¯æ¿å
-¥ãããã»ã«ã®ãã¼ã
-  #    ãã®ã¡ã½ããã¯ get_rhs_cell ã¨å¯¾ã«ãªã£ã¦ãã
+  #=== Join# 右辺のポートを得る
+  #    右辺が composite の場合は、内部の繋がるセルのポート, through の場合は挿入されたセルのポート
+  #    このメソッドは get_rhs_cell と対になっている
   def get_rhs_port
-    # through æå®ããï¼
+    # through 指定あり？
     if @through_list[0] then
-      # mikan through ã§çæãããã®ã root namespace éå®
-      # through ã§çæãããã»ã«ãæ¢ã
+      # mikan through で生成したものが root namespace 限定
+      # through で生成されたセルを探す
 #      cell = Namespace.find( [ "::", @through_generated_list[0].get_cell_name.to_sym ] )    #1
       cell = Namespace.find( @through_generated_list[0].get_cell_namespace_path )    #1
-      # cell ã®ãã©ã°ã¤ã³ã§çæããããã¼ãåã®ãã¼ããæ¢ã (composite ãªãå
-é¨ã®ç¹ãããã¼ã)
+      # cell のプラグインで生成されたポート名のポートを探す (composite なら内部の繋がるポート)
       return cell.get_real_port( @through_generated_list[0].get_through_entry_port_name )
     else
-      # ãã¼ããè¿ã(composite ãªãå
-é¨ã®ç¹ãããã¼ããè¿ã)
+      # ポートを返す(composite なら内部の繋がるポートを返す)
       return @cell.get_real_port( @port_name )
     end
   end
 
-  #=== Join# å³è¾ºã®ãã¼ããå¾ã
-  # å³è¾ºã®ãã¼ããå¾ãã
-  # ããã¯ãã­ãã¿ã¤ãå®£è¨ããããã¦ããªãå ´åã«ã¯ããã¡ãããä½¿ããªã
+  #=== Join# 右辺のポートを得る
+  # 右辺のポートを得る。
+  # これはプロトタイプ宣言しかされていない場合には、こちらしか使えない
   def get_rhs_port2
-    # through æå®ããï¼
+    # through 指定あり？
     if @through_list[0] then
       if @through_generated_list[0] then
         port = @through_generated_list[0].get_through_entry_port_name.to_sym
       else
-        port = @port_name    # generate ã«å¤±æãã¦ãã
+        port = @port_name    # generate に失敗している
       end
     else
@@ -5942,6 +5636,6 @@
   end
 
-  #=== Join# å³è¾ºã®ãã¼ããå¾ã
-  # through ã¯é©ç¨ããªãããcomposite ã¯å±éããå¾ã®ã»ã«ã®å¯¾å¿ãããã¼ã
+  #=== Join# 右辺のポートを得る
+  # through は適用しないが、composite は展開した後のセルの対応するポート
   def get_rhs_port3
     if @cell then
@@ -5950,38 +5644,29 @@
   end
 
-  #=== Join# å¼ã³å£é
-åã®2çªç®ä»¥éã®è¦ç´ ãè¿½å ãã
-  #     ä¸çªæåã«å®ç¾©ãããé
-åè¦ç´ ãå
-¨è¦ç´ ã®åæå¤ã®é
-åãæã¤
-  #     ãã®ã¡ã½ããã¯éé
-åã®å ´åãå¼åºãããï¼join éè¤ã¨ã©ã¼ã®å ´åï¼
-  #join2:: Join  å¼ã³å£é
-åè¦ç´ ã® Join
+  #=== Join# 呼び口配列の2番目以降の要素を追加する
+  #     一番最初に定義された配列要素が全要素の初期値の配列を持つ
+  #     このメソッドは非配列の場合も呼出される（join 重複エラーの場合）
+  #join2:: Join  呼び口配列要素の Join
   def add_array_member join2
 
-    # subscript2: join2 ã®å·¦è¾ºæ·»æ°
+    # subscript2: join2 の左辺添数
     subscript2 = join2.get_subscript
 
     if @subscript == nil then		# not array : initialize duplicate
-      # éé
-åã®å ´åãjoin ãéè¤ãã¦ãã
+      # 非配列の場合、join が重複している
       cdl_error( "S1127 \'$1\' duplicate", @name )
       # print "add_array_member2: #{@owner.get_name}\n"
 
     elsif @subscript >= 0 then
-      # æ·»æ°æå®ããã®å ´å
+      # 添数指定ありの場合
       if( subscript2 == nil || subscript2 < 0 ) then
-        # join2 å·¦è¾ºã¯éé
-åã¾ãã¯æ·»æ°ãªã
-        # é
-åãä¸ä¸è´
+        # join2 左辺は非配列または添数なし
+        # 配列が不一致
         cdl_error( "S1128 \'$1\' inconsistent array definition", @name )
       elsif @array_member[subscript2] != nil then
-        # åãæ·»æ°ãæ¢ã«å®ç¾©æ¸ã¿
+        # 同じ添数が既に定義済み
         cdl_error( "S1129 \'$1\' redefinition of subscript $2" ,@name, subscript2 )
       else
-        # æ·»æ°ã®ä½ç½®ã«è¦ç´ ãè¿½å 
+        # 添数の位置に要素を追加
         @array_member[subscript2] = join2.get_rhs
         @array_member2[subscript2] = join2
@@ -5990,16 +5675,12 @@
 
     else
-      # æ·»æ°æå®ãªãã®å ´å
+      # 添数指定なしの場合
       if( subscript2 == nil || subscript2 >= 0 ) then
-        # join2 å·¦è¾ºã¯éé
-åã¾ãã¯æ·»æ°æ
-        # é
-åãä¸ä¸è´
+        # join2 左辺は非配列または添数有
+        # 配列が不一致
         cdl_error( "S1130 \'R1\' inconsistent array definition", @name )
       end
 
-      # æ·»æ°ãªãé
-åã®å ´åãé
-åè¦ç´ ãè¿½å 
+      # 添数なし配列の場合、配列要素を追加
       @array_member  << join2.get_rhs
       @array_member2 << join2
@@ -6025,8 +5706,7 @@
       while i < @array_member2.length
         if @array_member2[i] != self && @array_member[i] != nil then
-          # @array_member2[i] ã nil ã«ãªãã®ã¯ optional ã®æã¨ã
-          # Join ã® initialize ã§ç¡é§ã« @array_member2 ãè¨­å®ããã¦ããå ´å
-          # ç¡é§ã«è¨­å®ããã¦ãããã®ã«ã¤ãã¦ã¯ãåå¸°çã«å¼ã³åºãå¿
-è¦ã¯ãªãï¼clone_for_composite ã§ã¯å¯¾ç­ãã¦ããï¼
+          # @array_member2[i] が nil になるのは optional の時と、
+          # Join の initialize で無駄に @array_member2 が設定されている場合
+          # 無駄に設定されているものについては、再帰的に呼び出す必要はない（clone_for_composite では対策している）
           @array_member2[i].change_name( name )
         end
@@ -6036,5 +5716,5 @@
   end
 
-  # composite cell ãå±éããã»ã«ã®çµåã clone ããã»ã«ã®ååã«å¤æ´
+  # composite cell を展開したセルの結合を clone したセルの名前に変更
   def change_rhs_port( clone_cell_list, celltype )
 
@@ -6054,20 +5734,15 @@
     dbgPrint "  cell_name:   #{@cell_name} => #{c.get_global_name}, #{c.get_name}\n"
 
-    # @rhs ã®å
-å®¹ãèª¿æ´ãã¦ããï¼ãã®å
-å®¹ã¯ãsubscript ãé¤ãã¦ãå¾ããä½¿ããã¦ããªãï¼
+    # @rhs の内容を調整しておく（この内容は、subscript を除いて、後から使われていない）
     elements = @rhs.get_elements
-    if elements[0] == :OP_SUBSC then  # å³è¾ºï¼åãå£é
-åï¼
+    if elements[0] == :OP_SUBSC then  # 右辺：受け口配列？
       elements  = elements[1]
     end
 
-    # å³è¾ºããcell.ePort ã®å½¢å¼ã§ãªã
+    # 右辺が　cell.ePort の形式でない
     if elements[0] != :OP_DOT || elements[1][0] != :IDENTIFIER then   #1
       return
     else
-      # ã»ã«åã composite å
-é¨ã®ååãããå¤é¨ã®ååã«å
-¥ãæ¿ãã
+      # セル名を composite 内部の名前から、外部の名前に入れ替える
       # elements[1][1] = Token.new( c.get_name, nil, nil, nil )
       elements[1][1] = NamespacePath.new( c.get_name, false, c.get_namespace )
@@ -6076,5 +5751,5 @@
     @cell_name = c.get_name
     @cell = c
-    # @definition = nil          # @definition ãæå¹ï¼ ãã§ãã¯æ¸ã¿ï¼ã¨ã¯ãããªãï¼
+    # @definition = nil          # @definition が有効： チェック済み（とは、しない）
 
     if @array_member2 then
@@ -6085,8 +5760,7 @@
       i = 0
       while i < @array_member2.length
-        # @array_member2[i] ã nil ã«ãªãã®ã¯ optional ã®æã¨ã
-        # Join ã® initialize ã§ç¡é§ã« @array_member2 ãè¨­å®ããã¦ããå ´å
-        # ç¡é§ã«è¨­å®ããã¦ãããã®ã«ã¤ãã¦ã¯ãåå¸°çã«å¼ã³åºãå¿
-è¦ã¯ãªãï¼clone_for_composite ã§ã¯å¯¾ç­ãã¦ããï¼
+        # @array_member2[i] が nil になるのは optional の時と、
+        # Join の initialize で無駄に @array_member2 が設定されている場合
+        # 無駄に設定されているものについては、再帰的に呼び出す必要はない（clone_for_composite では対策している）
         if @array_member2[i] != self && @array_member[i] != nil then
           @array_member2[i].change_rhs_port( clone_cell_list, celltype )
@@ -6098,12 +5772,10 @@
   end
 
-  #=== Join# composite ã»ã«ç¨ã«ã¯ã­ã¼ã³
-  #cell_global_name:: string : è¦ªã»ã«ã®ã°ã­ã¼ãã«å
-  # å³è¾ºã® C_EXP ã«å«ã¾ãã $id$, $cell$, $ct$ ãç½®æ
-  # ããã§ç½®æããã®ã¯ composite ã® attribute ã® C_EXP ã composite ã»ã«ã¿ã¤ãããã³ã»ã«åã«ç½®æãããã
-  # ï¼å
-é¨ã»ã«ã® C_EXP ãããã§ç½®æãããï¼
-  # @through_list ãªã©ãã³ãã¼ãããã®ã§ããããå¼ã³åºãããåã«ç¢ºå®ããå¿
-è¦ããã
+  #=== Join# composite セル用にクローン
+  #cell_global_name:: string : 親セルのグローバル名
+  # 右辺の C_EXP に含まれる $id$, $cell$, $ct$ を置換
+  # ここで置換するのは composite の attribute の C_EXP を composite セルタイプおよびセル名に置換するため
+  # （内部セルの C_EXP もここで置換される）
+  # @through_list などもコピーされるので、これが呼び出される前に確定する必要がある
   def clone_for_composite( ct_name, cell_name, locale, b_need_recursive = true )
 
@@ -6125,20 +5797,18 @@
 
   def clone_array_member( array_member, array_member2, ct_name, cell_name, prev, locale )
-    # é
-åã®ã³ãã¼ãä½ã
+    # 配列のコピーを作る
     am  = array_member.clone
     am2 = array_member2.clone
 
-    # é
-åè¦ç´ ã®ã³ãã¼ãä½ã
+    # 配列要素のコピーを作る
     i = 0
     while i < am2.length
       if array_member2[i] == prev then
-        # èªåèªèº«ã§ããï¼ã®ã§ãå¼åºãã¨ç¡éåå¸°å¼åºãã¨ãªãï¼
+        # 自分自身である（ので、呼出すと無限再帰呼出しとなる）
         am2[i] = self
       elsif array_member2[i] then
         am2[i] = array_member2[i].clone_for_composite( ct_name, cell_name, locale, false )
       else
-        # ä»¥åã®ã¨ã©ã¼ã§ array_member2[i] ã¯ nil ã«ãªã£ã¦ãã
+        # 以前のエラーで array_member2[i] は nil になっている
       end
 
@@ -6149,5 +5819,5 @@
     end
 
-    # i = 0 ã¯ãããã§èªåèªèº«ãè¨­å®
+    # i = 0 は、ここで自分自身を設定
     # am2[0] = self
 
@@ -6157,17 +5827,14 @@
   end
 
-  #=== Join# rhs ãå
-¥ãæãã
+  #=== Join# rhs を入れ換える
   #rhs:: Expression | initializer
-  # å³è¾ºãå
-¥ãæããï¼
-  # ãã®ã¡ã½ããã¯ãcomposite ã§ cell ã®å±æ§ã®åæå¤ã attribute ã®å¤ã§ç½®ãæããã®ã«ä½¿ããã
-  # ãã®ã¡ã½ããã¯ composite å
-ã® cell ã®å±æ§ã®åæå¤ãå®æ°ã§ã¯ãªãå¼ã«ãªã£ãå ´åãä¸è¦ã«ãªã
+  # 右辺を入れ換える．
+  # このメソッドは、composite で cell の属性の初期値を attribute の値で置き換えるのに使われる
+  # このメソッドは composite 内の cell の属性の初期値が定数ではなく式になった場合、不要になる
   def change_rhs rhs
     @rhs = rhs
   end
 
-  #=== Join# clone ããã join ã® owner ãå¤æ´
+  #=== Join# clone された join の owner を変更
   def set_cloned( owner )
     dbgPrint "Join#set_cloned: #{@name}  prev owner: #{@owner.get_name} new owner: #{owner.get_name}\n"
@@ -6255,5 +5922,5 @@
 end
 
-#== éçµå
+#== 逆結合
 class ReverseJoin < BDNode
 #@ep_name:: Symbol
@@ -6280,14 +5947,11 @@
 end
 
-# CLASS: CompositeCelltype ç¨ã® Join
-# REM:   CompositeCelltype ã export ãããã®
+# CLASS: CompositeCelltype 用の Join
+# REM:   CompositeCelltype が export するもの
 class CompositeCelltypeJoin < BDNode
-# @export_name:: string     :  CompositeCelltype ã export ããååï¼å¼ã³å£ãåãå£ãå±æ§ï¼
-# @internal_cell_name:: string : CompositeCelltype å
-é¨ã®ã»ã«ã®åå
-# @internal_cell_elem_name:: string : CompositeCelltype å
-é¨ã®ã»ã«ã®å¼ã³å£ãåãå£ãå±æ§ã®åå
-# @cell : Cell : Cell::  internal cell  : CompositeCelltyep å
-é¨ã®ã»ã«ï¼in_compositeã»ã«ï¼
+# @export_name:: string     :  CompositeCelltype が export する名前（呼び口、受け口、属性）
+# @internal_cell_name:: string : CompositeCelltype 内部のセルの名前
+# @internal_cell_elem_name:: string : CompositeCelltype 内部のセルの呼び口、受け口、属性の名前
+# @cell : Cell : Cell::  internal cell  : CompositeCelltyep 内部のセル（in_compositeセル）
 # @port_decl:: Port | Decl
 # @b_pseudo: bool : 
@@ -6304,9 +5968,9 @@
   end
 
-  #=== CompositeCelltypeJoin# CompositeCelltypeJoin ã®å¯¾è±¡ã»ã«ãï¼
-  #cell::  Cell å¯¾è±¡ãã©ãããã§ãã¯ããã»ã«
+  #=== CompositeCelltypeJoin# CompositeCelltypeJoin の対象セルか？
+  #cell::  Cell 対象かどうかチェックするセル
   #
-  #     CompositeCelltypeJoin ã¨ cell ã®ååãä¸è´ããããã§ãã¯ãã
-  #     port_decl ãæå®ãããå ´åã¯ãç¾ç¶ä½¿ããã¦ããªã
+  #     CompositeCelltypeJoin と cell の名前が一致するかチェックする
+  #     port_decl が指定された場合は、現状使われていない
   def match?( cell, port_decl = nil )
 
@@ -6324,6 +5988,6 @@
 
 #    if @cell.equal?( cell ) && ( port_decl == nil || @port_decl.equal?( port_decl ) ) then
-    # ãªã port_decl ãä¸è´ããªããã°ãªããªãã£ããå¿ããã
-    # recursive_composite ã§ååã®ä¸è´ã«å¤æ´   060917
+    # なぜ port_decl が一致しなければならなかったか忘れた。
+    # recursive_composite で名前の一致に変更   060917
     if((@cell.get_name == cell.get_name) && (port_decl == nil || @port_decl.get_name == port_decl.get_name))then
       true
@@ -6357,5 +6021,5 @@
   end
 
-  # @port_decl ã Port ã®å ´åã®ã¿å¼ã³åºãã¦ãã
+  # @port_decl が Port の場合のみ呼び出してよい
   def get_port_type
     if @port_decl then
@@ -6379,5 +6043,5 @@
   end
 
-  # @port_decl ã Port ã®å ´åã®ã¿å¼ã³åºãã¦ãã
+  # @port_decl が Port の場合のみ呼び出してよい
   def is_require?
     if @port_decl then
@@ -6386,5 +6050,5 @@
   end
 
-  # @port_decl ã Port ã®å ´åã®ã¿å¼ã³åºãã¦ãã
+  # @port_decl が Port の場合のみ呼び出してよい
   def is_allocator_port?
     if @port_decl then
@@ -6393,5 +6057,5 @@
   end
 
-  # @port_decl ã Port ã®å ´åã®ã¿å¼ã³åºãã¦ãã
+  # @port_decl が Port の場合のみ呼び出してよい
   def is_optional?
     if @port_decl then
@@ -6400,6 +6064,6 @@
   end
 
-  #=== CompositeCelltypeJoin# å³è¾ºã Decl ãªãã°åæåå­ï¼å¼ï¼ãè¿ã
-  # ãã®ã¡ã½ããã¯ Cell ã® check_join ããåæå¤ãã§ãã¯ã®ããã«å¼ã³åºããã
+  #=== CompositeCelltypeJoin# 右辺が Decl ならば初期化子（式）を返す
+  # このメソッドは Cell の check_join から初期値チェックのために呼び出される
   def get_initializer
     if @port_decl.instance_of? Decl then
@@ -6414,13 +6078,12 @@
   end
 
-  #=== CompositeCelltypeJoin# é
-åãµã¤ãºãå¾ã
-  #RETURN:: nil: not array, "[]": å¤§ããæå®ãªã, Integer: å¤§ããæå®ãã
+  #=== CompositeCelltypeJoin# 配列サイズを得る
+  #RETURN:: nil: not array, "[]": 大きさ指定なし, Integer: 大きさ指定あり
   def get_array_size
     @port_decl.get_array_size
   end
 
-  #=== CompositeCelltypeJoin# signature ãå¾ã
-  # @port_decl ã Port ã®æã®ã¿å¼ã³åºãã¦ããã
+  #=== CompositeCelltypeJoin# signature を得る
+  # @port_decl が Port の時のみ呼び出してもよい
   def get_signature
     @port_decl.get_signature
@@ -6465,5 +6128,5 @@
 # @file_name:: string
 # @format:: string
-# @arg_list:: Expression ã® elements ã¨åãå½¢å¼ [ [:IDENTIFIER, String], ... ]
+# @arg_list:: Expression の elements と同じ形式 [ [:IDENTIFIER, String], ... ]
 # @f_celltype:: bool : true: celltype factory, false: cell factory
 
@@ -6476,27 +6139,26 @@
     case name
     when :write
-      # write é¢æ°
+      # write 関数
       @name = name
 
-      # write é¢æ°ã®ç¬¬ä¸å¼æ°ï¼åºåå
-ãã¡ã¤ã«å
-        # å¼ãè©ä¾¡ããï¼éå¸¸åä¸ã®æå­åã§ãããããåä¸ã®æå­åãè¿ãããï¼
+      # write 関数の第一引数：出力先ファイル名
+        # 式を評価する（通常単一の文字列であるから、単一の文字列が返される）
       @file_name = file_name.eval_const(nil).val  # file_name : Expression
       if ! @file_name.instance_of?( String ) then
-        # æå­åå®æ°ã§ã¯ãªãã£ã
+        # 文字列定数ではなかった
         cdl_error( "S1132 $1: 1st parameter is not string(file name)" , @name )
         @file_name = nil
       end
 
-      # write é¢æ°ã®ç¬¬äºå¼æ°ï¼ãã©ã¼ãããæå­å
+      # write 関数の第二引数：フォーマット文字列
       @format    = format.eval_const(nil).val     # format : Expression
-        # å¼ãè©ä¾¡ããï¼éå¸¸åä¸ã®æå­åã§ãããããåä¸ã®æå­åãè¿ãããï¼
+        # 式を評価する（通常単一の文字列であるから、単一の文字列が返される）
       if ! @format.instance_of?( String ) then
-        # æå­åå®æ°ã§ã¯ãªãã£ã
+        # 文字列定数ではなかった
         cdl_error( "S1133 $1: 2nd parameter is not string(fromat)" , @name )
         @format = nil
       end
 
-      # ç¬¬ä¸å¼æ°ä»¥éãå¼æ°ãªã¹ãã¨ãã mikan å¼æ°ã®ãã§ãã¯
+      # 第三引数以降を引数リストとする mikan 引数のチェック
       @arg_list = arg_list
 
@@ -6575,17 +6237,17 @@
 #== Domain
 #
-# region ã® domain ãè¨æ¶ããã¯ã©ã¹
+# region の domain を記憶するクラス
 class DomainType < Node
-#@name::Symbol : ãã¡ã¤ã³ã¿ã¤ãã®åå ex) HRP2
+#@name::Symbol : ドメインタイプの名前 ex) HRP2
 #@region::Region
 #@plugin_name::Symbol : ex) HRP2Plugin
 #@option::String : ex) "trusted", "nontrusted"
-#@plugin::DomainPlugin ã®å­ã¯ã©ã¹
+#@plugin::DomainPlugin の子クラス
 
   include PluginModule
 
-  # ãã¡ã¤ã³ã«å±ãã region ã® Hash
-  # domain æå®ãä¸åº¦ãè¡ãããªãå ´åããã®ãªã¹ãã¯ç©ºã§ãã
-  # ã«ã¼ããªã¼ã¸ã§ã³ã¯ option = "OutOfDomain" ã§ç»é²ããã (domain æå®ãç¡ããã°ç»é²ãããªã)
+  # ドメインに属する region の Hash
+  # domain 指定が一度も行われない場合、このリストは空である
+  # ルートリージョンは option = "OutOfDomain" で登録される (domain 指定が無ければ登録されない)
   @@domain_regions = { }  # { :domain_type => [ region, ... ] }
 
@@ -6628,7 +6290,6 @@
   end
 
-  #== Domain ãªã¼ã¸ã§ã³ã® Hash ãå¾ã
-  # @@domain_regions ã®èª¬æåç
-§
+  #== Domain リージョンの Hash を得る
+  # @@domain_regions の説明参照
   def self.get_domain_regions
     return @@domain_regions
@@ -6649,28 +6310,28 @@
 end
 
-#== Region ã¯ã©ã¹
+#== Region クラス
 # 
-# Region ã¯ Namespace ãç¶æ¿ãã¦ãã
-# root region ã¯ç¹æ®ã§ãroot namespace ã¨åãã§ãã
+# Region は Namespace を継承している
+# root region は特殊で、root namespace と同じである
 #
-# cell ã¯ region ã«å±ãã
-# region ã«å±ãã cell ã®ãªã¹ãã¯ Namespace ã¯ã©ã¹ã®ã¤ã³ã¹ã¿ã³ã¹å¤æ°ã¨ãã¦è¨æ¶ããã
+# cell は region に属する
+# region に属する cell のリストは Namespace クラスのインスタンス変数として記憶される
 #
 class Region < Namespace
 # @name:: string
-# @in_through_list:: [ [ plugin_name, plugin_arg ], ... ] : plungin_name = nil ã®æ in ç¦æ­¢
-# @out_through_list:: [ [ plugin_name, plugin_arg ], ... ] : plungin_name = nil ã®æ out ç¦æ­¢
+# @in_through_list:: [ [ plugin_name, plugin_arg ], ... ] : plungin_name = nil の時 in 禁止
+# @out_through_list:: [ [ plugin_name, plugin_arg ], ... ] : plungin_name = nil の時 out 禁止
 # @to_through_list:: [ [ dst_region, plugin_name, plugin_arg ], ... ]
-# @cell_port_throug_plugin_list:: { "#{cell_name}.#{port_name}" => through_generated_list ã®è¦ç´  }
-#    ãã® region ãã cell_name.port_name ã¸ã® through ãã©ã°ã¤ã³ã§çæããããªãã¸ã§ã¯ã
+# @cell_port_throug_plugin_list:: { "#{cell_name}.#{port_name}" => through_generated_list の要素 }
+#    この region から cell_name.port_name への through プラグインで生成されたオブジェクト
 # @region_type::Symbol : :NODE, :LINKUNIT, :DOMAIN, :CLASS
-# @region_type_param::Symbol : domain, class ã®åå. node, linkunit ã§ã¯ nil
-# @link_root:: Region : linkUnit ã®æ ¹ã£ãã¨ãªã region (node, linkunit ãæå®ããã region)
-# @family_line:: [ @region_root, ...,@region_me ]  å®¶ç³»
-# @in_through_count:: Integer :  n çªç®ã® in_through çµå (n>=0)
-# @out_through_count:: Integer : n çªç®ã® out_through çµå (n>=0)
-# @to_through_count:: { :RegionName => Integer }: RegionName ã¸ã® n çªç®ã® to_through çµå (n>=0)
-# @domain_type::DomainType : domain æå®ããã¦ããªãå ´åãnil
-# @domain_root::Region : domain æå®ããã¦ããªã Region (root ã®å ´å nil)
+# @region_type_param::Symbol : domain, class の名前. node, linkunit では nil
+# @link_root:: Region : linkUnit の根っことなる region (node, linkunit が指定された region)
+# @family_line:: [ @region_root, ...,@region_me ]  家系
+# @in_through_count:: Integer :  n 番目の in_through 結合 (n>=0)
+# @out_through_count:: Integer : n 番目の out_through 結合 (n>=0)
+# @to_through_count:: { :RegionName => Integer }: RegionName への n 番目の to_through 結合 (n>=0)
+# @domain_type::DomainType : domain 指定されていない場合、nil
+# @domain_root::Region : domain 指定されていなる Region (root の場合 nil)
 
   @@in_through_list  = []
@@ -6680,16 +6341,15 @@
   @@region_type_param = nil
   @@domain_name = nil
-  @@domain_option = nil    # Token ãå
-¥ã
+  @@domain_option = nil    # Token が入る
 
   @@link_roots = []
 
   def initialize( name )
-    # mikan name ã® Namespace ä¿®é£¾
-    # object = Namespace.find( [ name ] )   # è¦ªã¾ã§æãã«ãã
+    # mikan name の Namespace 修飾
+    # object = Namespace.find( [ name ] )   # 親まで捜しにいく
     if name != "::" then
       object = Namespace.get_current.find( name )    #1
     else
-      # root ãªã¼ã¸ã§ã³
+      # root リージョン
       object = nil
       @@region_type = :NODE
@@ -6727,5 +6387,5 @@
         dbgPrint "Region.new: re-appear #{@name}\n"
 
-        # # Region path ãåååºç¾ã¨ä¸è´ãããï¼
+        # # Region path が前回出現と一致するか？
         # if @@region_stack[ @@region_stack_sp - 1 ] then
         #   my_path = @@region_stack[ @@region_stack_sp - 1 ].get_path_string.to_s + "." + @name.to_s
@@ -6737,8 +6397,8 @@
         # end
 
-        # ååºç¾
+        # 再出現
         # @@region_stack[@@region_stack_sp] = object
 
-        # ååºç¾æã« specifier ãæå®ããã¦ãããï¼
+        # 再出現時に specifier が指定されているか？
         if( @in_through_list.length != 0 || @out_through_list.length != 0 || @to_through_list.length != 0 || @region_type != nil )then
           cdl_error( "S1140 $1: region specifier must place at first appearence" , name )
@@ -6747,12 +6407,12 @@
 
       else
-        # ã¨ã©ã¼ç¨ããã¼å®ç¾©
-
-        # ç°ãªãååã®ãªãã¸ã§ã¯ããå®ç¾©æ¸ã¿
+        # エラー用ダミー定義
+
+        # 異なる同名のオブジェクトが定義済み
         cdl_error( "S1141 $1 duplication, previous one : $2" , name, object.class )
-        # @@region_stack[@@region_stack_sp] = self    # ã¨ã©ã¼ææ«å® region
-      end
-    else
-      # ååºç¾
+        # @@region_stack[@@region_stack_sp] = self    # エラー時暫定 region
+      end
+    else
+      # 初出現
       dbgPrint "Region.new: #{@name}\n"
       set_region_family_line
@@ -6807,6 +6467,6 @@
   end
 
-  #== Region ã«ã¼ããªã¼ã¸ã§ã³ãå¾ã
-  # ã«ã¼ããªã¼ã¸ã§ã³ã¯ãã«ã¼ããã¼ã ã¹ãã¼ã¹ã¨åãã§ãã
+  #== Region ルートリージョンを得る
+  # ルートリージョンは、ルートネームスペースと同じである
   def self.get_root
     Namespace.get_root
@@ -6816,5 +6476,5 @@
 
     dbgPrint  "set_region_family_line: Region: #{@name}  \n"
-    # root namespace (root region) ã® region type ã¯ :NODE
+    # root namespace (root region) の region type は :NODE
     if @name == "::" then
       @region_type = :NODE
@@ -6834,7 +6494,6 @@
 
     if @domain_type then
-      # ã«ã¼ããªã¼ã¸ã§ã³ãæåãã @domain_type è¨­å®ããããã¨ã¯ãªãã®
-      # ã§ @owner == nil ãèª¿ã¹ãå¿
-è¦ã¯ãªã
+      # ルートリージョンが最初から @domain_type 設定されることはないの
+      # で @owner == nil を調べる必要はない
       @owner.set_domain_type @domain_type
     end
@@ -6850,12 +6509,9 @@
     @link_root = nil
 
-    # @family_line ãä½æãã
-    # @link_root ãã¿ã¤ãã
-    # (ä¸ä½ã«ãã©ã£ã¦ãã£ã¦ Region ã§ node ã¾ãã¯ linkunit ã®ããããå
-ã«è¦ã¤ãã£ããã®ã @link_root ã¨ãªã)
-    # root namespace ã¯ Region ãã¤ node ãªã®ã§å¿
-ã @link_root ã¯è¦ã¤ãã
-    # mikan: self ã node, linkUnit ã®å ´åãããã§æå¾
-ããã¨ããã«è¨­å®ãããªããããRegion#initialize ã§åè¨­å®
+    # @family_line を作成する
+    # @link_root もみつける
+    # (上位にたどっていって Region で node または linkunit のいずれか先に見つかったものが @link_root となる)
+    # root namespace は Region かつ node なので必ず @link_root は見つかる
+    # mikan: self が node, linkUnit の場合、ここで期待したとおりに設定されないため、Region#initialize で再設定
     obj = self
     while 1
@@ -6868,9 +6524,9 @@
         end
       else
-        # ãããªããã° Namespace
-        # namespace ã®ä¸ã« region ãããå ´å
-      end
-
-      # root namespace ã«ãã©ãçãã°çµã
+        # さもなければ Namespace
+        # namespace の下に region がある場合
+      end
+
+      # root namespace にたどり着けば終り
       break if obj.get_name == "::"
 
@@ -6883,5 +6539,5 @@
   end
 
-  #== Region#ãã¡ã¤ã³ãè¨­å®ãã
+  #== Region#ドメインを設定する
   def set_domain_type domain_type
     if @region_type == :NODE then
@@ -6927,8 +6583,8 @@
   end
 
-  #== Region# domain ã®æ ¹ã£ãã¨ãªã region ãå¾ã
-  # Region ã®ã¤ã³ã¹ã¿ã³ã¹ãè¿ã
-  # domain æå®å­ãããã°ããã®ãªã¼ã¸ã§ã³ããã¡ã¤ã³ã«ã¼ãã§ãã
-  # ãªããã°ãè¦ªãªã¼ã¸ã§ã³ã®ãã¡ã¤ã³ã«ã¼ãã¨ãã
+  #== Region# domain の根っことなる region を得る
+  # Region のインスタンスを返す
+  # domain 指定子があれば、そのリージョンがドメインルートである
+  # なければ、親リージョンのドメインルートとする
   def get_domain_root
     @domain_root
@@ -6970,8 +6626,7 @@
   end
 
-  #=== Region# æ§æè§£æä¸­ã® region ãå¾ã
-  # æ§æè§£æä¸­ Namespace (ãããã¯å­ã¯ã©ã¹ã® Region) ã®ä¸ä½ããã©ã£ã¦ Region ãè¦ã¤ãã
-  # cell ã namespace ä¸ã«ãããã¨ãã§ããªããã°ãã«ã¼ããã¾ããå¿
-è¦ã¯ãªã
+  #=== Region# 構文解析中の region を得る
+  # 構文解析中 Namespace (あるいは子クラスの Region) の上位をたどって Region を見つける
+  # cell が namespace 下におくことができなければ、ループをまわす必要はない
   def self.get_current
     # @@region_stack[@@region_stack_sp]
@@ -6986,6 +6641,6 @@
   end
 
-  #=== Region# through ãã©ã°ã¤ã³ã§ããã® region ãã cell_name.port_name ã¸ã®ãã©ã°ã¤ã³ãªãã¸ã§ã¯ããç»é²
-  # mikan namesppace å¯¾å¿ (cell_name)
+  #=== Region# through プラグインで、この region から cell_name.port_name へのプラグインオブジェクトを登録
+  # mikan namesppace 対応 (cell_name)
   def add_cell_port_through_plugin( cell_name, port_name, through_plugin_object )
     @cell_port_throug_plugin_list[ "#{cell_name}.#{port_name}" ] = through_plugin_object
@@ -7002,17 +6657,16 @@
   end
 
-  #=== Region# to_region ã¸ã®è·é¢ï¼unreachable ãªå ´å nil)
-  # mikan Cell#check_region ã¨Region ã¸ãã©ãçãã¾ã§ããã®å¦çã«å
-±éæ§ãé«ã
-  # region#distance ã¯ require ã§ç¨ãããã
+  #=== Region# to_region への距離（unreachable な場合 nil)
+  # mikan Cell#check_region とRegion へたどり着くまでための処理に共通性が高い
+  # region#distance は require で用いられる
   def distance( to_region )
 
-    r1 = self                   # åºçº region
-    r2 = to_region              # ç®ç region
+    r1 = self                   # 出発 region
+    r2 = to_region              # 目的 region
     dist = 0
 
-    if ! r1.equal? r2 then      # åä¸ region ãªãå¼åºãå¯è½
-
-      # mikan namespace å¯¾å¿
+    if ! r1.equal? r2 then      # 同一 region なら呼出し可能
+
+      # mikan namespace 対応
       f1 = r1.get_family_line
       len1 = f1.length
@@ -7020,8 +6674,6 @@
       len2 = f2.length
 
-      # ä¸ä¸è´ã«ãªãã¨ããï¼å
-å¼ï¼ãæ¢ã
-      i = 1  # i = 0 ã¯ :RootRegion ãªã®ã§å¿
-ãä¸è´
+      # 不一致になるところ（兄弟）を探す
+      i = 1  # i = 0 は :RootRegion なので必ず一致
       while( i < len1 && i < len2 )
         if( f1[i] != f2[i] )then
@@ -7031,6 +6683,5 @@
       end
 
-      sibling_level = i     # å
-å¼ã¨ãªãã¬ãã«ããããã¯ã©ã¡ããä¸æ¹ãçµãã£ãã¬ãã«
+      sibling_level = i     # 兄弟となるレベル、もしくはどちらか一方が終わったレベル
 
       # p "sibling_level: #{i}"
